diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
index 68869919e..08ede7be9 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.world.generate.chunk.perlin.overworld;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.core.block.BlockLogicLeavesBase;
 import net.minecraft.core.block.BlockLogicMoss;
 import net.minecraft.core.block.BlockLogicOreCoal;
@@ -21,17 +22,29 @@ import net.minecraft.core.world.biome.overworld.BiomeOutback;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.ChunkDecorator;
 import net.minecraft.core.world.generate.feature.*;
+import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.type.tag.WorldTypeTags;
 import org.jetbrains.annotations.NotNull;
+import org.slf4j.Logger;
 
 import java.util.Random;
 
 public class ChunkDecoratorOverworld
     implements ChunkDecorator {
+    private static final @NotNull Logger LOGGER = LogUtils.getLogger();
+
     private final @NotNull World world;
     private final @NotNull FractalNoise2D<ImprovedPerlinNoise> treeDensityNoise;
     private final int treeDensityOverride;
 
+    private static void runStep(@NotNull String name, int chunkX, int chunkZ, @NotNull Runnable action) {
+        try {
+            action.run();
+        } catch (final Throwable t) {
+            LOGGER.error("Decoration step '{}' failed at chunk ({}, {}); continuing.", name, chunkX, chunkZ, t);
+        }
+    }
+
     protected ChunkDecoratorOverworld(@NotNull World world, int treeDensityOverride) {
         this.world = world;
         this.treeDensityOverride = treeDensityOverride;
@@ -46,8 +59,12 @@ public class ChunkDecoratorOverworld
     @Override
     public void decorate(@NotNull Chunk chunk) {
         this.world.scheduledUpdatesAreImmediate = true;
-        int chunkX = chunk.pos.x;
-        int chunkZ = chunk.pos.z;
+        BlockLogicFallingBlock.fallInstantly = true;
+
+        final int chunkX = chunk.pos.x;
+        final int chunkZ = chunk.pos.z;
+
+        try {
 
         int minY = this.world.getWorldType().getMinY(world);
         int maxY = this.world.getWorldType().getMaxY(world);
@@ -55,7 +72,6 @@ public class ChunkDecoratorOverworld
 
         float oreHeightModifier = rangeY / 128f;
 
-        BlockLogicFallingBlock.fallInstantly = true;
         int x = chunkX * 16;
         int z = chunkZ * 16;
         int y = this.world.getHeightValue(x + 16, z + 16);
@@ -67,6 +83,7 @@ public class ChunkDecoratorOverworld
         Random swampRand = new Random((long) chunkX * l1 + (long) chunkZ * l2 ^ this.world.getRandomSeed());
 
         // Water pass for swamps
+        try {
         if (biome.hasTag(BiomeTags.HAS_SURFACE_WATER)) {
             for (int dx = 0; dx < 16; dx++) {
                 for (int dz = 0; dz < 16; dz++) {
@@ -95,7 +112,9 @@ public class ChunkDecoratorOverworld
                 }
             }
         }
+        } catch (final Throwable t) { LOGGER.error("Decoration step 'swamp_water' failed at chunk ({}, {}); continuing.", chunkX, chunkZ, t); }
 
+        try {
         int lakeChance = 4;
         if (biome == Biomes.OVERWORLD_SWAMPLAND)
             lakeChance = 2;
@@ -119,6 +138,9 @@ public class ChunkDecoratorOverworld
                 new WorldFeatureLake(Blocks.FLUID_LAVA_STILL.id()).place(this.world, rand, xf, yf, zf);
             }
         }
+        } catch (final Throwable t) { LOGGER.error("Decoration step 'lakes' failed at chunk ({}, {}); continuing.", chunkX, chunkZ, t); }
+
+        try {
         for (int k1 = 0; k1 < (8 * oreHeightModifier); k1++) {
             int j5 = x + rand.nextInt(16) + 8;
             int k8 = minY + rand.nextInt(rangeY);
@@ -148,7 +170,9 @@ public class ChunkDecoratorOverworld
                 new WorldFeatureDungeon(Blocks.COBBLE_BASALT.id(), Blocks.COBBLE_BASALT_MOSSY.id(), null).place(this.world, rand, j5, k8, j11);
             }
         }
+        } catch (final Throwable t) { LOGGER.error("Decoration step 'dungeons' failed at chunk ({}, {}); continuing.", chunkX, chunkZ, t); }
 
+        try {
         for (int k1 = 0; k1 < 1; k1++) {
             int j5 = x + rand.nextInt(16) + 8;
             int j11 = z + rand.nextInt(16) + 8;
@@ -164,7 +188,9 @@ public class ChunkDecoratorOverworld
                 (new WorldFeatureLabyrinth()).place(this.world, lRand, j5, k8, j11);
             }
         }
+        } catch (final Throwable t) { LOGGER.error("Decoration step 'labyrinth' failed at chunk ({}, {}); continuing.", chunkX, chunkZ, t); }
 
+        try {
         for (int i2 = 0; i2 < (20 * oreHeightModifier); i2++) {
             int k5 = x + rand.nextInt(16);
             int l8 = minY + rand.nextInt(rangeY);
@@ -186,71 +212,83 @@ public class ChunkDecoratorOverworld
                 (new WorldFeaturePermaice(32 + rand.nextInt(32), Blocks.PERMAFROST)).place(this.world, rand, j7, k10, j13);
             }
         }
+        } catch (final Throwable t) { LOGGER.error("Decoration step 'clay_dirt_permaice' failed at chunk ({}, {}); continuing.", chunkX, chunkZ, t); }
 
+        try {
         for (int j2 = 0; j2 < (20 * oreHeightModifier); j2++) {
             int l5 = x + rand.nextInt(16);
             int i9 = minY + rand.nextInt(rangeY);
             int l11 = z + rand.nextInt(16);
-            (new WorldFeatureOre(Blocks.DIRT.id(), 32)).place(this.world, rand, l5, i9, l11);
+            TilePos queryPos = new TilePos(l5, i9, l11);
+            (new WorldFeatureOre(Blocks.DIRT.id(), 32)).place(this.world, rand, queryPos);
         }
 
         for (int k2 = 0; k2 < (10 * oreHeightModifier); k2++) {
             int i6 = x + rand.nextInt(16);
             int j9 = minY + rand.nextInt(rangeY);
             int i12 = z + rand.nextInt(16);
-            (new WorldFeatureOre(Blocks.GRAVEL.id(), 32)).place(this.world, rand, i6, j9, i12);
+            TilePos queryPos = new TilePos(i6, j9, i12);
+            (new WorldFeatureOre(Blocks.GRAVEL.id(), 32)).place(this.world, rand, queryPos);
         }
 
         for (int i3 = 0; i3 < (20 * oreHeightModifier); i3++) {
             int j6 = x + rand.nextInt(16);
             int k9 = minY + rand.nextInt(rangeY);
             int j12 = z + rand.nextInt(16);
-            new WorldFeatureOre(BlockLogicOreCoal.variantMap, 16).place(this.world, rand, j6, k9, j12);
+            TilePos queryPos = new TilePos(j6, k9, j12);
+            new WorldFeatureOre(BlockLogicOreCoal.variantMap, 16).place(this.world, rand, queryPos);
         }
 
         for (int j3 = 0; j3 < (20 * oreHeightModifier); j3++) {
             int k6 = x + rand.nextInt(16);
             int l9 = minY + rand.nextInt(rangeY / 2);
             int k12 = z + rand.nextInt(16);
-            (new WorldFeatureOre(BlockLogicOreIron.variantMap, 8)).place(this.world, rand, k6, l9, k12);
+            TilePos queryPos = new TilePos(k6, l9, k12);
+            (new WorldFeatureOre(BlockLogicOreIron.variantMap, 8)).place(this.world, rand, queryPos);
         }
 
         for (int k3 = 0; k3 < (2 * oreHeightModifier); k3++) {
             int l6 = x + rand.nextInt(16);
             int i10 = minY + rand.nextInt(rangeY / 4);
             int l12 = z + rand.nextInt(16);
-            (new WorldFeatureOre(BlockLogicOreGold.variantMap, 8)).place(this.world, rand, l6, i10, l12);
+            TilePos queryPos = new TilePos(l6, i10, l12);
+            (new WorldFeatureOre(BlockLogicOreGold.variantMap, 8)).place(this.world, rand, queryPos);
         }
 
         for (int l3 = 0; l3 < (8 * oreHeightModifier); l3++) {
             int i7 = x + rand.nextInt(16);
             int j10 = minY + rand.nextInt(rangeY / 8);
             int i13 = z + rand.nextInt(16);
-            (new WorldFeatureOre(BlockLogicOreRedstone.variantMap, 7)).place(this.world, rand, i7, j10, i13);
+            TilePos queryPos = new TilePos(i7, j10, i13);
+            (new WorldFeatureOre(BlockLogicOreRedstone.variantMap, 7)).place(this.world, rand, queryPos);
         }
 
         for (int i4 = 0; i4 < oreHeightModifier; i4++) {
             int j7 = x + rand.nextInt(16);
             int k10 = minY + rand.nextInt(rangeY / 8);
             int j13 = z + rand.nextInt(16);
-            (new WorldFeatureOre(BlockLogicOreDiamond.variantMap, 7)).place(this.world, rand, j7, k10, j13);
+            TilePos queryPos = new TilePos(j7, k10, j13);
+            (new WorldFeatureOre(BlockLogicOreDiamond.variantMap, 7)).place(this.world, rand, queryPos);
         }
 
         for (int i4 = 0; i4 < oreHeightModifier; i4++) {
             int j7 = x + rand.nextInt(16);
             int k10 = minY + rand.nextInt(rangeY / 2);
             int j13 = z + rand.nextInt(16);
-            (new WorldFeatureMoss(BlockLogicMoss.variantMap, 32)).place(this.world, rand, j7, k10, j13);
+            TilePos queryPos = new TilePos(j7, k10, j13);
+            (new WorldFeatureMoss(BlockLogicMoss.variantMap, 32)).place(this.world, rand, queryPos);
         }
 
         for (int j4 = 0; j4 < oreHeightModifier; j4++) {
             int k7 = x + rand.nextInt(16);
             int l10 = minY + rand.nextInt(rangeY / 8) + rand.nextInt(rangeY / 8);
             int k13 = z + rand.nextInt(16);
-            (new WorldFeatureOre(BlockLogicOreLapis.variantMap, 6)).place(this.world, rand, k7, l10, k13);
+            TilePos queryPos = new TilePos(k7, l10, k13);
+            (new WorldFeatureOre(BlockLogicOreLapis.variantMap, 6)).place(this.world, rand, queryPos);
         }
+        } catch (final Throwable t) { LOGGER.error("Decoration step 'ores' failed at chunk ({}, {}); continuing.", chunkX, chunkZ, t); }
 
-
+        try {
         double d = 0.5D;
         int k4 = (int) ((this.treeDensityNoise.getValue((double) x * d, (double) z * d) / 8D + rand.nextDouble() * 4D + 4D) / 3D);
         int treeDensity = 0;
@@ -300,15 +338,24 @@ public class ChunkDecoratorOverworld
         try {
             BlockLogicLeavesBase.enableDecay = false;
             for (int i11 = 0; i11 < treeDensity; i11++) {
-                int l13 = x + rand.nextInt(16) + 8;
-                int j14 = z + rand.nextInt(16) + 8;
-                WorldFeature feature = biome.getTreeFeature(rand);
-                feature.init(1.0D, 1.0D, 1.0D);
-                feature.place(this.world, rand, l13, this.world.getHeightValue(l13, j14), j14);
+                // Per-tree try/catch: a single bad placement (e.g. NPE inside a tree feature)
+                // would otherwise abort the rest of the forest and produce visible cutoffs.
+                try {
+                    int l13 = x + rand.nextInt(16) + 8;
+                    int j14 = z + rand.nextInt(16) + 8;
+                    WorldFeature feature = biome.getTreeFeature(rand);
+                    feature.init(1.0D, 1.0D, 1.0D);
+                    feature.place(this.world, rand, l13, this.world.getHeightValue(l13, j14), j14);
+                } catch (final Throwable treeT) {
+                    LOGGER.error("Tree placement #{} failed at chunk ({}, {}); continuing.", i11, chunkX, chunkZ, treeT);
+                }
             }
         } finally {
             BlockLogicLeavesBase.enableDecay = true;
         }
+        } catch (final Throwable t) { LOGGER.error("Decoration step 'trees' failed at chunk ({}, {}); continuing.", chunkX, chunkZ, t); }
+
+        try {
         byte byteReeds = 0;
         if (biome == Biomes.OVERWORLD_RAINFOREST) {
             byteReeds = 1;
@@ -363,7 +410,9 @@ public class ChunkDecoratorOverworld
             int j24 = z + rand.nextInt(16) + 8;
             (new WorldFeatureFlowers(blockId, 128, true)).place(this.world, rand, l19, k22, j24);
         }
+        } catch (final Throwable t) { LOGGER.error("Decoration step 'reeds_orchids_meadows' failed at chunk ({}, {}); continuing.", chunkX, chunkZ, t); }
 
+        try {
         byte byteBluebells = 0;
         if (biome == Biomes.OVERWORLD_FOREST) {
             byteBluebells = 2;
@@ -435,7 +484,9 @@ public class ChunkDecoratorOverworld
             int k19 = z + rand.nextInt(16) + 8;
             (new WorldFeatureFlowers(Blocks.FLOWER_YELLOW.id(), 64, true)).place(this.world, rand, k14, l16, k19);
         }
+        } catch (final Throwable t) { LOGGER.error("Decoration step 'flowers_blue_orange_yellow' failed at chunk ({}, {}); continuing.", chunkX, chunkZ, t); }
 
+        try {
         byte byte1 = 0;
         if (biome == Biomes.OVERWORLD_FOREST) {
             byte1 = 2;
@@ -502,7 +553,9 @@ public class ChunkDecoratorOverworld
             int l22 = z + rand.nextInt(16) + 8;
             (new WorldFeatureDeadBush(Blocks.DEADBUSH.id())).place(this.world, rand, i17, i20, l22);
         }
+        } catch (final Throwable t) { LOGGER.error("Decoration step 'tallgrass_spinifex_deadbush' failed at chunk ({}, {}); continuing.", chunkX, chunkZ, t); }
 
+        try {
         if (rand.nextInt(2) == 0) {
             int j15 = x + rand.nextInt(16) + 8;
             int j17 = minY + rand.nextInt(rangeY);
@@ -554,7 +607,9 @@ public class ChunkDecoratorOverworld
             int k24 = z + rand.nextInt(16) + 8;
             (new WorldFeatureCactus()).place(this.world, rand, k21, j23, k24);
         }
+        } catch (final Throwable t) { LOGGER.error("Decoration step 'mushrooms_pumpkin_sponge_cactus' failed at chunk ({}, {}); continuing.", chunkX, chunkZ, t); }
 
+        try {
         for (int l18 = 0; l18 < 50; l18++) {
             int l21 = x + rand.nextInt(16) + 8;
             int k23 = minY + rand.nextInt(rand.nextInt(rangeY - (rangeY / 16)) + (rangeY / 16));
@@ -568,7 +623,9 @@ public class ChunkDecoratorOverworld
             int i25 = z + rand.nextInt(16) + 8;
             (new WorldFeatureLiquid(Blocks.FLUID_LAVA_FLOWING.id())).place(this.world, rand, i22, l23, i25);
         }
+        } catch (final Throwable t) { LOGGER.error("Decoration step 'liquids' failed at chunk ({}, {}); continuing.", chunkX, chunkZ, t); }
 
+        try {
         int numPebbles = 0;
         if (biome == Biomes.OVERWORLD_FOREST) {
             numPebbles = 2;
@@ -598,31 +655,104 @@ public class ChunkDecoratorOverworld
             final int zz = z + rand.nextInt(16) + 8;
             new WorldFeaturePebbles(Blocks.OVERLAY_PEBBLES, 16, true).place(this.world, rand, xx, yy, zz);
         }
+        } catch (final Throwable t) { LOGGER.error("Decoration step 'pebbles' failed at chunk ({}, {}); continuing.", chunkX, chunkZ, t); }
 
-        int oceanY = this.world.getWorldType().getOceanY();
-        for (int dx = x + 8; dx < x + 8 + 16; dx++) {
-            for (int dz = z + 8; dz < z + 8 + 16; dz++) {
-                int dy = this.world.getHeightValue(dx, dz);
-                Biome localBiome = this.world.getBlockBiome(dx, dy, dz);
-
-                if ((localBiome.hasTag(BiomeTags.HAS_SURFACE_SNOW) || this.world.getWorldType().hasTag(WorldTypeTags.ENDLESS_SNOW)) &&
-                    dy > 0 && dy < this.world.getHeightBlocks())
-                {
-                    if (this.world.isAirBlock(dx, dy, dz) && this.world.getBlockMaterial(dx, dy - 1, dz).blocksMotion()) {
-                        this.world.setBlockWithNotify(dx, dy, dz, Blocks.LAYER_SNOW.id());
+        // Snow/ice pass
+        final int oceanY = this.world.getWorldType().getOceanY();
+        try {
+            for (int dx = x + 8; dx < x + 8 + 16; dx++) {
+                for (int dz = z + 8; dz < z + 8 + 16; dz++) {
+                    try {
+                        applySnowAndIceForColumn(dx, dz, oceanY);
+                    } catch (final Throwable colT) {
+                        LOGGER.error("Snow/ice column ({}, {}) failed at chunk ({}, {}); continuing.", dx, dz, chunkX, chunkZ, colT);
                     }
                 }
-                if ((localBiome.hasTag(BiomeTags.HAS_SURFACE_ICE) || this.world.getWorldType().hasTag(WorldTypeTags.ENDLESS_SNOW)) &&
-                    (this.world.getBlockId(dx, oceanY - 1, dz) == Blocks.FLUID_WATER_STILL.id() || this.world.getBlockId(dx, oceanY - 1, dz) == Blocks.FLUID_WATER_FLOWING.id())
-                ) {
-                    this.world.setBlockWithNotify(dx, oceanY - 1, dz, Blocks.ICE.id());
-                }
+            }
+        } catch (final Throwable t) { LOGGER.error("Decoration step 'snow_ice' failed at chunk ({}, {}); continuing.", chunkX, chunkZ, t); }
 
+        // Spillover re-snow pass
+        try {
+            for (int dx = x; dx < x + 32; dx++) {
+                for (int dz = z; dz < z + 32; dz++) {
+                    final int ownerChunkX = (dx - 8) >> 4;
+                    final int ownerChunkZ = (dz - 8) >> 4;
+                    if (ownerChunkX == chunkX && ownerChunkZ == chunkZ) { continue; }
+                    if (!this.world.isChunkLoaded(ownerChunkX, ownerChunkZ)) { continue; }
+                    final Chunk owner = this.world.getChunkFromChunkCoords(ownerChunkX, ownerChunkZ);
+                    if (!owner.isTerrainPopulated) { continue; }
+                    final int physicalChunkX = dx >> 4;
+                    final int physicalChunkZ = dz >> 4;
+                    if (!this.world.isChunkLoaded(physicalChunkX, physicalChunkZ)) { continue; }
+                    try {
+                        applySnowAndIceForColumn(dx, dz, oceanY);
+                    } catch (final Throwable colT) {
+                        LOGGER.error("Spillover snow/ice column ({}, {}) failed at chunk ({}, {}); continuing.", dx, dz, chunkX, chunkZ, colT);
+                    }
+                }
             }
+        } catch (final Throwable t) { LOGGER.error("Decoration step 'snow_ice_spillover' failed at chunk ({}, {}); continuing.", chunkX, chunkZ, t); }
 
+        } finally {
+            BlockLogicFallingBlock.fallInstantly = false;
+            this.world.scheduledUpdatesAreImmediate = false;
         }
+    }
 
-        BlockLogicFallingBlock.fallInstantly = false;
-        this.world.scheduledUpdatesAreImmediate = false;
+    /**
+     * Places snow on the topmost surface of the column AND on the ground beneath any
+     * tree canopy in the column, plus ice on top of water at the ocean surface.
+     * Existing snow is not duplicated. Safe to call multiple times for the same column
+     */
+    private void applySnowAndIceForColumn(final int dx, final int dz, final int oceanY) {
+        final int dy = this.world.getHeightValue(dx, dz);
+        final Biome localBiome = this.world.getBlockBiome(dx, dy, dz);
+
+        final boolean wantsSnow = localBiome.hasTag(BiomeTags.HAS_SURFACE_SNOW) || this.world.getWorldType().hasTag(WorldTypeTags.ENDLESS_SNOW);
+        if (wantsSnow && dy > 0 && dy < this.world.getHeightBlocks()) {
+            if (this.world.isAirBlock(dx, dy, dz) && this.world.getBlockMaterial(dx, dy - 1, dz).blocksMotion()) {
+                this.world.setBlockWithNotify(dx, dy, dz, Blocks.LAYER_SNOW.id());
+            }
+            final int minScanY = Math.max(1, dy - 32);
+            boolean passedTree = false;
+            for (int scanY = dy - 1; scanY > minScanY; scanY--) {
+                final int hereId = this.world.getBlockId(dx, scanY, dz);
+                final net.minecraft.core.block.Block<?> here = hereId > 0 ? Blocks.blocksList[hereId] : null;
+                if (here != null && (here.getLogic() instanceof BlockLogicLeavesBase || here.getMaterial() == Materials.WOOD)) {
+                    passedTree = true;
+                    continue;
+                }
+                if (here == Blocks.LAYER_SNOW) {
+                    continue;
+                }
+                if (hereId == 0) {
+                    if (!passedTree) { continue; }
+                    final int belowId = this.world.getBlockId(dx, scanY - 1, dz);
+                    if (belowId == 0) { continue; }
+                    final net.minecraft.core.block.Block<?> below = Blocks.blocksList[belowId];
+                    if (below == null) { continue; }
+                    if (below == Blocks.LAYER_SNOW) { continue; }
+                    if (below.getLogic() instanceof BlockLogicLeavesBase) {
+                        this.world.setBlockWithNotify(dx, scanY, dz, Blocks.LAYER_SNOW.id());
+                        continue;
+                    }
+                    if (below.getMaterial() == Materials.WOOD) { continue; }
+                    if (below.getMaterial().blocksMotion()) {
+                        this.world.setBlockWithNotify(dx, scanY, dz, Blocks.LAYER_SNOW.id());
+                        break;
+                    }
+                    continue;
+                }
+                break;
+            }
+        }
+
+        final boolean wantsIce = localBiome.hasTag(BiomeTags.HAS_SURFACE_ICE) || this.world.getWorldType().hasTag(WorldTypeTags.ENDLESS_SNOW);
+        if (wantsIce) {
+            final int oceanFluidId = this.world.getBlockId(dx, oceanY - 1, dz);
+            if (oceanFluidId == Blocks.FLUID_WATER_STILL.id() || oceanFluidId == Blocks.FLUID_WATER_FLOWING.id()) {
+                this.world.setBlockWithNotify(dx, oceanY - 1, dz, Blocks.ICE.id());
+            }
+        }
     }
 }
